SystemOrganization addCategory: #'GMF-DataManager'!

Object subclass: #DataModel
	instanceVariableNames: 'elements'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GMF-DataManager'!

!DataModel class methodsFor: 'instance creation' stamp: 'RostislavNovk 10/28/2013 21:08'!
new
	^ super new
		initialize;
		yourself! !

!DataModel methodsFor: 'accessing' stamp: 'RostislavNovk 11/3/2013 13:29'!
add: dataClass
	elements add: dataClass.! !

!DataModel methodsFor: 'accessing' stamp: 'RostislavNovk 11/3/2013 13:29'!
asMetaModel
	| metaModel |
	metaModel := MetaModel new.
	elements do: [ :e | metaModel addElement: (e metaModelClass)  ].
	^metaModel.
	! !

!DataModel methodsFor: 'accessing' stamp: 'RostislavNovk 10/28/2013 21:05'!
elements
	^elements copy.! !

!DataModel methodsFor: 'initialize-release' stamp: 'RostislavNovk 10/28/2013 21:05'!
initialize
	elements := OrderedCollection new.! !

!DataModel methodsFor: 'accessing' stamp: 'RostislavNovak 11/27/2013 23:20'!
remove: dataClass
	elements remove: dataClass.! !

!DataModel methodsFor: 'initialize-release' stamp: 'LukasKoc 12/1/2013 13:26'!
saveFile
	"comment stating purpose of message"

	| file xx yy w h attrib type nam |
	file := FileManip new.
	attrib := OrderedCollection new .
	file preparationForSave.
	elements do:[ :e | 
		file isClass: 1.
		xx := ((e positionClass) leftTopPoint ) x .
		yy := ((e positionClass) leftTopPoint ) y .
		w := xx - (((e positionClass) rightBottomPoint ) x).
		h := yy - (((e positionClass) rightBottomPoint ) y).
		type := ((e metaModelClass ) modelElements ) className. 
		nam :=  ((e metaModelClass ) modelElements ) name.
		file saveX: xx  Y: yy .
		file saveW: w H: h .
		attrib add: 'bg=light_gray'.
		attrib add: '&lt;&lt;',type,'&gt;&gt; '.
		attrib add: '*',nam,'*'.
		attrib add: '--'.
		((e metaModelClass ) modelElements ) attributs do:[ :a | attrib add: a ].
		attrib add: '--'.
		((e metaModelClass ) modelElements ) methods do:[ :a | attrib add: a ].
		file addAttributes: attrib.
		attrib removeAll.
		].

	file finishFile.! !
